﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data ;
using System.Data.SqlClient;
using System.IO;

//Copyright Myron R. Joy 2010
//Web page control that displays a page with the options to build a select statement that is then passed to RdlcRptGen and shows a report.
//Selection page can include several datasources. 

namespace UserQueryCtl

    /// <summary>
    /// Copyright Myron R. Joy 2010
    /// Web page control that displays a page with the options to build a select statement that is then passed to RdlcRptGen and shows a report.
    /// Selection page can include several datasources. 
    /// To use add Refeence to project, then drop on web page. Add code to select datasource. 
    /// var TestDs = new DataSet("TestDs");
    /// TestDs.ReadXmlSchema(MapPath("AdWorkSC.xml"));
    /// TestDs.ReadXml(MapPath("AdWorkDT.xml"));
    /// UserQuery1.AddDataSources("AdWorks", TestDs.Tables[0], true);
    /// </summary
    
{
    [DefaultProperty("Text")]
    [ToolboxData("<{0}:UserQuery runat=server></{0}:UserQuery>")]
    public class UserQuery : CompositeControl
    {
        private List<string> ErrorListMes;
        private List<string> ErrorListCode;
        private Label ErrorLabel;
        
        private DataTable _DataTable;
        private bool _isShowRptBtnClick;
        private SqlDataAdapter  _SqlAdapter;
        private string _RptHeader;
        private bool _TrialVertion;
        
        private ListBox lboxAvalible;
        private Label lblBoxAvalible;
        private ListBox lboxSelect;
        private Label lblBoxSelect;
        
        private Microsoft.Reporting.WebForms.ReportViewer RptViewer;
        private Button btnSel;
        private Button btnRemove;
        private DropDownList dlSort;
        private Label lblSort;
        private Literal litSortLbl;
        private Literal litSort;
        private Literal lit;
        private Literal litBr;
        private Literal litEnd;
        private Label lblFilter;
        private Literal litFilter;
        private DropDownList dlAndOr1;
        private DropDownList dlFields1;
        private DropDownList dlEqual1;
        private TextBox tbFilter1;
        private DropDownList dlAndOr2;
        private DropDownList dlFields2;
        private DropDownList dlEqual2;
        private TextBox tbFilter2;
        private Literal litBr2;
        private DropDownList dlAndOr3;
        private DropDownList dlFields3;
        private DropDownList dlEqual3;
        private TextBox tbFilter3;
        private Literal litBr3;
        private DropDownList dlGrpBy;
        private Label lblGrpBy;
        private ListBox lbTotGrpOn;
        private Label lblTotGrpOn;
        private ListBox lbTotRptOn;
        private Label lblTotRptOn;
        private Literal litTotOn;
        private Label lblSelRptTyp;
        private CheckBox CbDisCntChart;

        private Label lbTitle;
        private TextBox tbRptTitle;
        private Button btnShowRpt;
        private string SqlStm;
        private string SqlStmFitler;
        private List<object> listDataSourceObjects;
        private DropDownList dlDataSourceObjects;
        private List<string> listDataSourceDisplay;
        private Label lblSelDataSource;
        private bool boolNewDataSource;
        private DropDownList dlRptTyp;
        private Literal litRptTyp;
        private List<string> DisCntDataPointsList;
        private Label lblxAxisChart;
        private Label lblyAxisChart;
        private TextBox tbxAxisLbl;
        private TextBox tbyAxisLbl;

        //Report Header
        /// <summary>
        /// The report header to display on the generated report.
        /// </summary>
        public string RptHeader
        {
            get { return _RptHeader; }
            set { _RptHeader = value; }
        }

        //Table Adabter. When used data is not called uptil after selections of fields.
        /// <summary>
        /// Pass a SqlAdapter to the control to report from the SQL source. The data will not be return to the program untill after
        /// the selection has seen selected. Use this option or the DataSource property to base query on a DataTable.
        /// </summary>
        public SqlDataAdapter SqlAdapter
        {
            //get { return _TblAdapter; }
            set 
            {
                //Fill database with one record to get the shema that is used in the user selection screen.
                _SqlAdapter  = value;

                if (value == null)
                    return;

                if ( _SqlAdapter.SelectCommand.CommandText.IndexOf("TOP(1)") == -1)
                    _SqlAdapter.SelectCommand.CommandText = _SqlAdapter.SelectCommand.CommandText.Replace("SELECT","SELECT TOP(1)"); 
                
                _DataTable = new DataTable();
                _SqlAdapter.Fill(_DataTable);
                //AddContolPropNoShowRpt();
                
            }
        }

        //When used without the SqlDataAdapter.
        /// <summary>
        /// This is the DataTable that is to be used for this report. Use this property or the SqlDataAdapter property.
        /// </summary>
        public DataTable DataSource
        {
            get { return _DataTable; }
            set 
            {
                if (_SqlAdapter != null)
                    return;
                
                _DataTable = value ;
                //AddContolPropNoShowRpt();
            
            }
        }

        /// <summary>
        /// Use this when adding multible datasources to the query.
        /// </summary>
        /// <param name="DisplayName">The name to be displayed in the drop down box for this datasource</param>
        /// <param name="DataSourceObject">The datasource object. A datatable or a SQL data adapter</param>
        /// <param name="LastDataSource"></param>False if this is not the last datasource to be added. 
        public void AddDataSources(string DisplayName, object DataSourceObject, bool LastDataSource)
        {
            
            if (listDataSourceObjects == null)
            {
                listDataSourceObjects = new List<object>();
                listDataSourceDisplay = new List<string>();
            }

            listDataSourceObjects.Add(DataSourceObject);
            listDataSourceDisplay.Add(DisplayName);

            if (!Page.IsPostBack)
                Page.Session["DsNum"] = 0;

            if (LastDataSource)
                LoadDataSource();
                    
        }

        //Loads selected datasource into query first time.
        private void LoadDataSource()
        {
            if (listDataSourceObjects == null)
                return;

            string TypeName = listDataSourceObjects[(int)Page.Session["DsNum"]].GetType().Name;

            if (TypeName.Contains("SqlDataAdapter"))
            {
                DataSource = null;
                SqlAdapter = (SqlDataAdapter)listDataSourceObjects[(int)Page.Session["DsNum"]];
            }
            else if (TypeName.Contains("DataTable"))
            {
                SqlAdapter = null;
                DataSource = (DataTable)listDataSourceObjects[(int)Page.Session["DsNum"]];
            }
        }

        //Change in type of report. Chart or record listing
        private void dlRptTyp_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (dlRptTyp.SelectedIndex != 0)
            {
                lblBoxAvalible.Text = "Available Data Points";
                lblBoxSelect.Text = "Selected Data Points";
                lblGrpBy.Text = "Chart Grouping";
                btnShowRpt.Text = "Show Chart";
                CbDisCntChart.Visible = true;
                lblxAxisChart.Visible = true;
                lblyAxisChart.Visible = true;
                tbxAxisLbl.Visible = true;
                tbyAxisLbl.Visible = true;
            }
            else
            {
                lblBoxAvalible.Text = "Available Fields";
                lblBoxSelect.Text = "Selected Fields";
                lblGrpBy.Text = "Group By";
                btnShowRpt.Text = "Show Report";
                //lboxSelect.Text = "Selected Fields";
                CbDisCntChart.Visible = false;
                lblxAxisChart.Visible = false;
                lblyAxisChart.Visible = false;
                tbxAxisLbl.Visible = false;
                tbyAxisLbl.Visible = false;

            }
               
        }

        //Loads selected datasource into query if selected in drop down box.
        private void dlDataSourceObjects_SelectedIndexChanged(object sender, EventArgs e)
        {
            Page.Session["DsNum"] = dlDataSourceObjects.SelectedIndex;
            LoadDataSource();
            boolNewDataSource = true;
            AddContolPropNoShowRpt();            
        }

        [DefaultValue(false)]
        private bool isShowRptBtnClick
        {
            get { return _isShowRptBtnClick; }
            set { _isShowRptBtnClick = value; }
        }


        //Add child controls to this conrol, called by base control. 
        protected override void CreateChildControls()
        {
                        
            _TrialVertion = true;
            
            Controls.Clear();

            //if the show report button has been clicked. Only show the report viewer.
            if (_isShowRptBtnClick)
            {
                RptViewer = new Microsoft.Reporting.WebForms.ReportViewer();
                RptViewer.ID = "RptView";
                //RptViewer.Style.Add("width", "720px");
                RptViewer.Width = System.Web.UI.WebControls.Unit.Parse("100%");
                //RptViewer.Height = System.Web.UI.WebControls.Unit.Parse("100%");
                RptViewer.ProcessingMode = Microsoft.Reporting.WebForms.ProcessingMode.Local;
                this.Controls.Add(RptViewer);

                return;
            }

            //Add error label
            ErrorLabel = new Label();
            
            if (_TrialVertion)
                ErrorLabel.Text = "Trial Version - www.rptgen.com -Copyright 2010";
            
            ErrorLabel.Style.Add("left", "25px");
            ErrorLabel.Style.Add("position", "absolute");
            this.Controls.Add(ErrorLabel);
            
            //Add datasourc selection box and label
            lblSelDataSource = new Label();
            lblSelDataSource.Text = "Selected Data Source:";
            lblSelDataSource.Style.Add("position", "absolute");
            lblSelDataSource.Style.Add("left", "25px");
            lblSelDataSource.Style.Add("top", "75px");
            this.Controls.Add(lblSelDataSource);

            dlDataSourceObjects = new DropDownList();
            dlDataSourceObjects.AutoPostBack = true;
            dlDataSourceObjects.TextChanged += new EventHandler(dlDataSourceObjects_SelectedIndexChanged);
            dlDataSourceObjects.Style.Add("position", "absolute");
            dlDataSourceObjects.Style.Add("left", "175px");
            dlDataSourceObjects.Style.Add("top", "75px");
            this.Controls.Add(dlDataSourceObjects);

            //Add avalible fields listbox
            lblBoxAvalible = new Label();
            lblBoxAvalible.Text = "Available Fields";
            lblBoxAvalible.Style.Add("top", "100px");
            lblBoxAvalible.Style.Add("left", "25px");
            lblBoxAvalible.Style.Add("position", "absolute");
            this.Controls.Add(lblBoxAvalible);

            lboxAvalible = new ListBox();
            lboxAvalible.ID = "lboxAvalible";
            lboxAvalible.Width = 100;
            lboxAvalible.Height = 275;
            lboxAvalible.Style.Add("top","115px");
            lboxAvalible.Style.Add("left", "25px");
            lboxAvalible.Style.Add("position", "absolute");
            this.Controls.Add(lboxAvalible);

            //Add Selected fields listbox
            lblBoxSelect = new Label();
            lblBoxSelect.Text = "Selected Fields";
            lblBoxSelect.Style.Add("top", "100px");
            lblBoxSelect.Style.Add("left", "250px");
            lblBoxSelect.Style.Add("position", "absolute");
            this.Controls.Add(lblBoxSelect);

            lboxSelect = new ListBox();
            lboxSelect.ID = "lboxSelect";
            lboxSelect.Width = 100;
            lboxSelect.Height = 275;
            lboxSelect.Style.Add("top", "115px");
            lboxSelect.Style.Add("left", "250px");
            lboxSelect.Style.Add("position", "absolute");
            this.Controls.Add(lboxSelect);

            //Add Distinctive Count check box for charts.
            CbDisCntChart = new CheckBox();
            CbDisCntChart.ID = "CbDisCntChart";
            CbDisCntChart.Style.Add("top", "150px");
            CbDisCntChart.Style.Add("left", "150px");
            CbDisCntChart.Style.Add("position", "absolute");
            CbDisCntChart.Text = "Add Distinct Count Data Point";
            CbDisCntChart.Width = 80;
            CbDisCntChart.Visible = false;
            this.Controls.Add(CbDisCntChart);


            //Add Select and Remove buttons
            btnSel = new Button();
            btnSel.ID = "btnSel";
            btnSel.Click += new EventHandler(btnSel_Click);
            btnSel.Text = "Select ->";
            btnSel.Width = 80;
            btnSel.Height = 25;
            btnSel.Style.Add("top", "250px");
            btnSel.Style.Add("left", "150px");
            btnSel.Style.Add("position", "absolute");
            this.Controls.Add(btnSel);

            //Add Select and Remove buttons
            btnRemove = new Button();
            btnRemove.ID = "btnRemove";
            btnRemove.Click += new EventHandler(btnRemove_Click);
            btnRemove.Text = "<- Remove";
            btnRemove.Width = 80;
            btnRemove.Height = 25;
            btnRemove.Style.Add("top", "285px");
            btnRemove.Style.Add("left", "150px");
            btnRemove.Style.Add("position", "absolute");
            this.Controls.Add(btnRemove);

            //Add filter boxes and sort box
            lit = new Literal();
            lit.Text = "<div style=\"position: absolute; top: 75px; left: 400px; \" >";
            this.Controls.Add(lit);

            //Add report type combo box 
            
            lblSelRptTyp = new Label();
            lblSelRptTyp.Text = "Selected Report Type:";
            //lblSelRptTyp.Style.Add("position", "absolute");
            //lblSelRptTyp.Style.Add("left", "25px");
            //lblSelChartTyp.Style.Add("top", "75px");
            this.Controls.Add(lblSelRptTyp);

            dlRptTyp = new DropDownList();
            dlRptTyp.AutoPostBack = true;
            dlRptTyp.TextChanged += new EventHandler(dlRptTyp_SelectedIndexChanged);
            dlRptTyp.Style.Add("position", "relative");
            dlRptTyp.Style.Add("left", "10px");
            //dlRptTyp.Style.Add("top", "75px");
            dlRptTyp.Items.Add("Record Listing");
            dlRptTyp.Items.Add("Pie Chart" );
            dlRptTyp.Items.Add("Column Chart");
            dlRptTyp.Items.Add("Line Chart");
            dlRptTyp.Items.Add("Bar Chart");
            this.Controls.Add(dlRptTyp);

            litRptTyp = new Literal();
            litRptTyp.Text = "<br />";
            this.Controls.Add(litRptTyp);

            //Add sort by and group by
            lblSort = new Label();
            lblSort.Text = "Sort By:";
            lblSort.Style.Add("position", "relative");
            //lblSort.Style.Add("left", "10px");
            lblSort.Style.Add("top", "5px");
            this.Controls.Add(lblSort);

            lblGrpBy = new Label();
            lblGrpBy.Text = "Group By:";
            lblGrpBy.Style.Add("position", "relative");
            lblGrpBy.Style.Add("left", "115px");
            lblGrpBy.Style.Add("top", "5px");
            this.Controls.Add(lblGrpBy);

            litSortLbl = new Literal();
            litSortLbl.Text = "<br />";
            this.Controls.Add(litSortLbl);

            dlSort = new DropDownList();
            dlSort.Style.Add("position", "relative");
            //dlSort.Style.Add("left", "115px");
            dlSort.Style.Add("top", "5px");
            this.Controls.Add(dlSort);

            dlGrpBy = new DropDownList();
            dlGrpBy.Style.Add("position","relative");
            dlGrpBy.Style.Add("top", "5px");
            dlGrpBy.Style.Add("left", "50px");
            this.Controls.Add(dlGrpBy);

            litSort = new Literal();
            litSort.Text = "<br /><br />";
            this.Controls.Add(litSort);

            lblFilter = new Label();
            lblFilter.Text = "Filter By:";
            this.Controls.Add(lblFilter);

            litFilter = new Literal();
            litFilter.Text = "<br />";
            this.Controls.Add(litFilter);

            dlAndOr1 = new DropDownList() ;
            dlAndOr1.Items.Add("AND");
            dlAndOr1.Items.Add("OR");
            this.Controls.Add(dlAndOr1);

            dlFields1 = new DropDownList();
            this.Controls.Add(dlFields1);

            dlEqual1 = new DropDownList();
            dlEqual1.Items.Add("Equal");
            dlEqual1.Items.Add("Not Equal");
            dlEqual1.Items.Add("Less than");
            dlEqual1.Items.Add("Greater than");
            this.Controls.Add(dlEqual1);

            tbFilter1 = new TextBox();
            tbFilter1.Style.Add("width", "100px");
            this.Controls.Add(tbFilter1);

            litBr = new Literal();
            litBr.Text = "<br />";
            this.Controls.Add(litBr);

            dlAndOr2 = new DropDownList();
            dlAndOr2.Items.Add("AND");
            dlAndOr2.Items.Add("OR");
            this.Controls.Add(dlAndOr2);

            dlFields2 = new DropDownList();
            this.Controls.Add(dlFields2);

            dlEqual2 = new DropDownList();
            dlEqual2.Items.Add("Equal");
            dlEqual2.Items.Add("Not Equal");
            dlEqual2.Items.Add("Less than");
            dlEqual2.Items.Add("Greater than");
            this.Controls.Add(dlEqual2);

            tbFilter2 = new TextBox();
            tbFilter2.Style.Add("width", "100px");
            this.Controls.Add(tbFilter2);

            litBr2 = new Literal();
            litBr2.Text = "<br />";
            this.Controls.Add(litBr2);

            dlAndOr3 = new DropDownList();
            dlAndOr3.Items.Add("AND");
            dlAndOr3.Items.Add("OR");
            this.Controls.Add(dlAndOr3);

            dlFields3 = new DropDownList();
            this.Controls.Add(dlFields3);

            dlEqual3 = new DropDownList();
            dlEqual3.Items.Add("Equal");
            dlEqual3.Items.Add("Not Equal");
            dlEqual3.Items.Add("Less than");
            dlEqual3.Items.Add("Greater than");
            
            this.Controls.Add(dlEqual3);

            tbFilter3 = new TextBox();
            tbFilter3.Style.Add("width", "100px");
            this.Controls.Add(tbFilter3);

            litBr3 = new Literal();
            litBr3.Text = "<br /><br />";
            this.Controls.Add(litBr3);

            lblTotRptOn = new Label();
            lblTotRptOn.Text = "Report Total On:";
            this.Controls.Add(lblTotRptOn);

            lblTotGrpOn = new Label();
            lblTotGrpOn.Text = "Group Total On:";
            lblTotGrpOn.Style.Add("position", "relative");
            lblTotGrpOn.Style.Add("left", "55px");
            this.Controls.Add(lblTotGrpOn);

            litTotOn = new Literal();
            litTotOn.Text = "<br />";
            this.Controls.Add(litTotOn);

            lbTotRptOn = new ListBox();
            lbTotRptOn.Width = 100;
            lbTotRptOn.Height = 110;
            lbTotRptOn.SelectionMode = ListSelectionMode.Multiple;
            this.Controls.Add(lbTotRptOn);

            lbTotGrpOn = new ListBox();
            lbTotGrpOn.Width = 100;
            lbTotGrpOn.Height = 110;
            lbTotGrpOn.SelectionMode = ListSelectionMode.Multiple;
            lbTotGrpOn.Style.Add("position", "relative");
            lbTotGrpOn.Style.Add("left", "65px");
            this.Controls.Add(lbTotGrpOn);

            litEnd = new Literal();
            litEnd.Text = "</div>";
            this.Controls.Add(litEnd);

            lblxAxisChart = new Label();
            lblxAxisChart.Text = "Chart X Axis Lable:";
            lblxAxisChart.Style.Add("position", "absolute");
            lblxAxisChart.Style.Add("top", "400px");
            lblxAxisChart.Style.Add("left", "25px");
            lblxAxisChart.Visible = false;
            this.Controls.Add(lblxAxisChart);

            tbxAxisLbl = new TextBox();
            tbxAxisLbl.Style.Add("position", "absolute");
            tbxAxisLbl.Style.Add("top", "400px");
            tbxAxisLbl.Style.Add("left", "150px");
            tbxAxisLbl.Width = 240;
            tbxAxisLbl.Visible = false;
            this.Controls.Add(tbxAxisLbl);

            lblyAxisChart = new Label();
            lblyAxisChart.Text = "Chart Y Axis Lable:";
            lblyAxisChart.Style.Add("position", "absolute");
            lblyAxisChart.Style.Add("top", "400px");
            lblyAxisChart.Style.Add("left", "400px");
            lblyAxisChart.Visible = false;
            this.Controls.Add(lblyAxisChart);

            tbyAxisLbl = new TextBox();
            tbyAxisLbl.Style.Add("position", "absolute");
            tbyAxisLbl.Style.Add("top", "400px");
            tbyAxisLbl.Style.Add("left", "525px");
            tbyAxisLbl.Width = 240;
            tbyAxisLbl.Visible = false;
            this.Controls.Add(tbyAxisLbl);

            lbTitle = new Label();
            lbTitle.Text = "Report Header:";
            lbTitle.Style.Add("position", "absolute");
            lbTitle.Style.Add("top", "425px");
            lbTitle.Style.Add("left", "25px");
            this.Controls.Add(lbTitle);

            
            
            tbRptTitle = new TextBox();
            if (_RptHeader == null)
                _RptHeader = "";
            tbRptTitle.Text = _RptHeader;
            tbRptTitle.Style.Add("width", "400px");
            tbRptTitle.Style.Add("top", "425px");
            tbRptTitle.Style.Add("left", "150px");
            tbRptTitle.Style.Add("position", "absolute");
            this.Controls.Add(tbRptTitle);

            btnShowRpt = new Button();
            btnShowRpt.Text = "Show Report";
            btnShowRpt.Click += new EventHandler(btnShowRpt_Click);
            btnShowRpt.Style.Add("top", "425px");
            btnShowRpt.Style.Add("left", "600px");
            btnShowRpt.Style.Add("position", "absolute");
            this.Controls.Add(btnShowRpt);

            AddContolPropNoShowRpt();
        }

        //If this is not the btn to show the report.
        /// <remarks>Add variable properties to controls to show query screen.</remarks>
        protected void AddContolPropNoShowRpt()
        {
            this.EnsureChildControls();

            //If postback, else
            if ((!Page.IsPostBack) | boolNewDataSource)
            {
                boolNewDataSource = false;
                
                //Add fields to avalible listbox array from datatable.
                lboxSelect.Items.Clear();

                //Add default select first
                dlSort.Items.Clear();
                dlSort.Items.Add("None");
                dlGrpBy.Items.Clear();
                dlGrpBy.Items.Add("None");
                lbTotGrpOn.Items.Clear();
                lbTotGrpOn.Items.Add("None");
                lbTotRptOn.Items.Add("None");

                lboxAvalible.Items.Clear();
                dlFields1.Items.Clear();
                dlFields2.Items.Clear();
                dlFields3.Items.Clear();
                lbTotRptOn.Items.Clear();
                lbTotGrpOn.Items.Clear();
                foreach (DataColumn dCol in _DataTable.Columns)
                {
                    lboxAvalible.Items.Add(dCol.Caption);
                    dlSort.Items.Add(dCol.Caption);
                    dlFields1.Items.Add(dCol.Caption);
                    dlFields2.Items.Add(dCol.Caption);
                    dlFields3.Items.Add(dCol.Caption);
                    dlGrpBy.Items.Add(dCol.Caption);
                     

                    if (dCol.DataType.ToString() != "System.String" & dCol.DataType.ToString() != "System.DateTime" )  
                    {
                        lbTotRptOn.Items.Add(dCol.Caption);
                        lbTotGrpOn.Items.Add(dCol.Caption);
                    }
                }

                //Add table items to control
                if (!Page.IsPostBack)
                {
                    for (int i = 0; i < listDataSourceDisplay.Count; i++)
                    {
                        dlDataSourceObjects.Items.Add(listDataSourceDisplay[i]);
                    }
                }
            }

        }

        //The button to move avalible fields to the selected fields.
        private void btnSel_Click(object source, EventArgs e)
        {
            for (int i = 0; i < lboxAvalible.Items.Count; i++)
            {
                if (lboxAvalible.Items[i].Selected)
                {
                    lboxAvalible.Items[i].Selected = false;
                    lboxAvalible.Items[i].Enabled = false;

                    if (CbDisCntChart.Checked)
                    {
                        lboxSelect.Items.Add(lboxAvalible.Items[i].Value +"*DC") ;
                        CbDisCntChart.Checked = false;
                    }
                    else
                        lboxSelect.Items.Add(lboxAvalible.Items[i].Value);

                }
            }
        }

        //Remove field from the selected fields to the avalible fields.
        private void btnRemove_Click(object source, EventArgs e)
        {
            for (int i = 0; i < lboxSelect.Items.Count; i++)
            {
                if (lboxSelect.Items[i].Selected)
                {

                    int DCindex = lboxSelect.Items[i].Value.IndexOf("*DC");
                    //string SelValue = lboxSelect.Items[i].Value;

                    if (DCindex != -1)
                        lboxSelect.Items[i].Value = lboxSelect.Items[i].Value.Substring(0, DCindex);


                    
                    for (int ii = 0; ii < lboxAvalible.Items.Count; ii++)
                    {
                        if (lboxSelect.Items[i].Value == lboxAvalible.Items[ii].Value)
                            lboxAvalible.Items[ii].Enabled = true;
                    }
                    lboxSelect.Items.Remove(lboxSelect.Items[i]);
                }
            }
        }

        //Show report button clicked.
        private void btnShowRpt_Click(object source, EventArgs e)
        {
            //Clear error label
            ErrorLabel.Text = "  ";

            if (btnShowRpt.Text == "Show Chart" & lboxSelect.Items.Count == 0)
            {
                ErrorLabel.Text = "Error-  Charts must have at least one Data Point selected."; 
                return;
            }


            _RptHeader = tbRptTitle.Text;
            
            //Convert all selected items from datatable captions to datatable fields names.
            foreach (DataColumn dCol in _DataTable.Columns)
            {
                //Convert selected fields and add group field is not already added.
                for (int iii = 0; iii < lboxSelect.Items.Count; iii++)
                {
                    //Get data point type for charts
                    int DirectCountIndex = (lboxSelect.Items[iii].Value).IndexOf("*DC");

                  
            

                    if (DirectCountIndex != -1)
                    {
                        lboxSelect.Items[iii].Value = lboxSelect.Items[iii].Value.Substring(0, DirectCountIndex);
                        
                        if (DisCntDataPointsList == null)
                            DisCntDataPointsList = new List<string>() ;
                        
                        DisCntDataPointsList.Add(lboxSelect.Items[iii].Value ); 
                    }


                    if (dCol.Caption == lboxSelect.Items[iii].Value)
                    {

                        
                        lboxSelect.Items[iii].Value = dCol.ColumnName;

                        //if (this.btnShowRpt.Text == "Show Chart")
                        //{
                        //    if (DirectCountIndex != -1)
                        //    {
                        //        DisCntDataPointsList.Add(dCol.ColumnName); 

                        //    }
                        //}
                    }
                }

                //Convert avalible fields
                for (int iii = 0; iii < lboxAvalible.Items.Count; iii++)
                {
                    if (dCol.Caption == lboxAvalible.Items[iii].Value)
                        lboxAvalible.Items[iii].Value = dCol.ColumnName;
                }

                //Convert sort fields
                for (int iii = 0; iii < dlSort.Items.Count; iii++)
                {
                    if (dCol.Caption == dlSort.Items[iii].Value)
                        dlSort.Items[iii].Value = dCol.ColumnName;
                }

                //Convert group by fields
                bool GrpByFldSelected = true;
                for (int iii = 0; iii < dlGrpBy.Items.Count; iii++)
                {
                    if (dCol.Caption == dlGrpBy.Items[iii].Value)
                        dlGrpBy.Items[iii].Value = dCol.ColumnName;


                    //Make sure group by field is included in selected fiels
                    GrpByFldSelected = false;
                    if (dlGrpBy.Items[iii].Selected == true 
                        & dlGrpBy.Items[iii].Value != "None" 
                        & lboxSelect.Items.Count != 0)
                        
                    {
                        for (int i = 0; i < lboxSelect.Items.Count; i++)
                        {
                            if (dlGrpBy.Items[iii].Value == lboxSelect.Items[i].Value)
                                GrpByFldSelected = true;
                        }

                        if (GrpByFldSelected == false)
                            lboxSelect.Items.Add(dlGrpBy.Items[iii].Value);


                    }

                }
                //Convert report total fields
                for (int iii = 0; iii < lbTotRptOn.Items.Count; iii++)
                {
                    if (dCol.Caption == lbTotRptOn.Items[iii].Value)
                        lbTotRptOn.Items[iii].Value = dCol.ColumnName;
                }

                //Convert group total fields
                for (int iii = 0; iii < lbTotGrpOn.Items.Count; iii++)
                {
                    if (dCol.Caption == lbTotGrpOn.Items[iii].Value)
                        lbTotGrpOn.Items[iii].Value = dCol.ColumnName;
                }

           }

            //datatable/dataview has not been filed, get the data or set the DV.
            if (_SqlAdapter == null)
                AddUserSelToDV();
            else if (_SqlAdapter != null)
                CallSelData();

            //If errors don't show report
            if (ErrorListMes != null)
            {
                ErrorLabel.Text = "Selection Error- " + ErrorListMes[0];
                return;
            }

            _isShowRptBtnClick = true;
            ChildControlsCreated = false;
            AddContolPropShowRpt();

        }

        //Make up selecton string.
        private void CallSelData()
        {
           SqlStm = "SELECT ";

            //Get selected fields or use all fields and add to select statement.
            var ColumnList = new string[lboxSelect.Items.Count];
            if (lboxSelect.Items.Count != 0)
            {
                for (int iii = 0; iii < lboxSelect.Items.Count; iii++)
                {
                    ColumnList[iii] = lboxSelect.Items[iii].Value;
                }
            }
            else
            {
                ColumnList = new string[lboxAvalible.Items.Count];
                for (int iii = 0; iii < lboxAvalible.Items.Count; iii++)
                {
                    ColumnList[iii] = lboxAvalible.Items[iii].Value;
                }
            }

            for (int i = 0; i < ColumnList.Count(); i++)
            {
                if (i == 0)
                    SqlStm = SqlStm + "[" + ColumnList[0] + "]";
                else
                    SqlStm = SqlStm + ", [" + ColumnList[i] + "]";
            }

            //Add From statement.
            string TmpWk = _SqlAdapter.SelectCommand.CommandText.ToString();
            int iSpos = TmpWk.IndexOf("FROM");
            SqlStm = SqlStm +"  "  +TmpWk.Substring(iSpos);
            

            
            //Add Filters
            //Add filters to select stm.
            SqlStmFitler = "";
            if (tbFilter1.Text != "")
                GetFilterSql(dlAndOr1, dlFields1, dlEqual1, tbFilter1) ;

            if (tbFilter2.Text != "")
                GetFilterSql(dlAndOr2, dlFields2, dlEqual2, tbFilter2 );

            if (tbFilter3.Text != "")
                GetFilterSql(dlAndOr3, dlFields3, dlEqual3, tbFilter3 );

            SqlStm = SqlStm + SqlStmFitler;

            //Set sort.
            //ORDER BY [Last Name] DESC ";
            for (int i = 0; i < dlSort.Items.Count; i++)
            {
                if (dlSort.Items[i].Selected & dlSort.Items[i].Value != "None")
                {
                    SqlStm = SqlStm +" ORDER BY [" +dlSort.Items[i].Value +"]";
                }
            }

            try
            {
                //Call data adapter to get data based on SqlStm
                _SqlAdapter.SelectCommand.CommandText = SqlStm;
                _DataTable = new DataTable();
                _SqlAdapter.Fill(_DataTable);
            }
            catch (Exception e)
            {
                ErrorHandler(e,"_SqlAdapter.Fill(_DataTable)");
            }
        }

        //Set filter for SQL statement.
        private void GetFilterSql(DropDownList DlAndOr, DropDownList DlFields, DropDownList DlEql, TextBox tbMatch)
        {
            string FilStr = SqlStmFitler ;
                            
            //Add AND OR statement
            for (int i = 0; i < DlAndOr.Items.Count; i++)
            {
                if (DlAndOr.Items[i].Selected == true)
                {
                    if (FilStr.Length != 0)
                        FilStr = FilStr + " " + DlAndOr.Items[i].Value;
                    else
                        FilStr = FilStr +" WHERE ";
                }
            }

            FilStr = FilStr + "(";

            //Add field
            for (int i = 0; i < DlFields.Items.Count; i++)
            {
                if (DlFields.Items[i].Selected == true)
                {
                    //if checking for null fiels, else normal
                    if (tbMatch.Text == "null")
                    {
                        FilStr = FilStr + "isNull([" + DlFields.Items[i].Value + "],'-1')";
                    }
                    else
                    {
                        FilStr = FilStr + "[" + DlFields.Items[i].Value + "]";
                    }
                }
            }

            for (int i = 0; i < DlEql.Items.Count; i++)
            {
                if (DlEql.Items[i].Selected == true)
                {

                    //if checking for null fiels, else normal
                    if (tbMatch.Text == "null")
                    {
                        if (DlEql.Items[i].Value == "Not Equal")
                            FilStr = FilStr + " <> '-1')";
                        else
                            FilStr = FilStr + " = '-1')";

                    }
                    else
                    {
                        if (DlEql.Items[i].Value == "Equal")
                            FilStr = FilStr + " = '" + tbMatch.Text + "')";

                        if (DlEql.Items[i].Value == "Not Equal")
                            FilStr = FilStr + " <> '" + tbMatch.Text + "')";

                        if (DlEql.Items[i].Value == "Less than")
                            FilStr = FilStr + " < '" + tbMatch.Text + "')";

                        if (DlEql.Items[i].Value == "Greater than")
                            FilStr = FilStr + " > '" + tbMatch.Text + "')";
                    }
                }
            }

            SqlStmFitler = FilStr;
        }

        //Add fileds, sort and filter to DataView
        private void AddUserSelToDV()
        {

            //Start dataview and add fields,sort, and filter.
            var DataViewObj = new DataView(_DataTable);

            //Get selected fields or use all fields.
            var ColumnList = new string[lboxSelect.Items.Count];
            if (lboxSelect.Items.Count != 0)
            {
                for (int iii = 0; iii < lboxSelect.Items.Count; iii++)
                {
                    ColumnList[iii] = lboxSelect.Items[iii].Value;
                }
            }
            else
            {
                ColumnList = new string[lboxAvalible.Items.Count];
                for (int iii = 0; iii < lboxAvalible.Items.Count; iii++)
                {
                    ColumnList[iii] = lboxAvalible.Items[iii].Value;
                }
            }

            //Add additional filters
            if (tbFilter1.Text != "")
                GetFilter(dlAndOr1, dlFields1, dlEqual1, tbFilter1, DataViewObj);

            if (tbFilter2.Text != "")
                GetFilter(dlAndOr2, dlFields2, dlEqual2, tbFilter2, DataViewObj);

            if (tbFilter3.Text != "")
                GetFilter(dlAndOr3, dlFields3, dlEqual3, tbFilter3, DataViewObj);

            //if (tbFilter4.Text != "")
            //   GetFilter(DlAndOr4, null, null, TbSel4);

            try
            {
                //Set sort.
                for (int i = 0; i < dlSort.Items.Count; i++)
                {
                    if (dlSort.Items[i].Selected)
                    {
                        if (dlSort.Items[i].Value != "None")
                            DataViewObj.Sort = dlSort.Items[i].Value;
                    }
                }
            }
            catch (Exception e)
            {
                ErrorHandler(e, "Major- Sort filer");
            }


            _DataTable = DataViewObj.ToTable(false, ColumnList);
        }

        //Get filter information from page
        private void GetFilter(DropDownList DlAndOr, DropDownList DlFields, DropDownList DlEql, TextBox tbMatch, DataView DV)
        {

            string FilStr = DV.RowFilter;

            //Add AND OR statement
            for (int i = 0; i < DlAndOr.Items.Count; i++)
            {
                if (DlAndOr.Items[i].Selected == true)
                {
                    if (FilStr.Length != 0)
                        FilStr = FilStr + " " + DlAndOr.Items[i].Value;
                    //else
                    //    FilStr = FilStr +"(";
                }
            }

             
            FilStr = FilStr + "(";

            //Add field
            for (int i = 0; i < DlFields.Items.Count; i++)
            {
                if (DlFields.Items[i].Selected == true)
                {
                    //if checking for null fiels, else normal
                    if (tbMatch.Text == "null")
                    {
                         FilStr = FilStr + "isNull([" + DlFields.Items[i].Value + "],'-1')";
                    }
                    else
                    {
                         FilStr = FilStr + "[" + DlFields.Items[i].Value + "]";
                    }
                }
            }

            for (int i = 0; i < DlEql.Items.Count; i++)
            {
                if (DlEql.Items[i].Selected == true)
                {

                    //if checking for null fiels, else normal
                    if (tbMatch.Text == "null")
                    {
                        if (DlEql.Items[i].Value == "Not Equal")
                            FilStr = FilStr + " <> '-1')";
                        else
                            FilStr = FilStr + " = '-1')";

                    }
                    else
                    {
                        if (DlEql.Items[i].Value == "Equal")
                            FilStr = FilStr + " = '" + tbMatch.Text + "')";

                        if (DlEql.Items[i].Value == "Not Equal")
                            FilStr = FilStr + " <> '" + tbMatch.Text + "')";

                        if (DlEql.Items[i].Value == "Less than")
                            FilStr = FilStr + " < '" + tbMatch.Text + "')";

                        if (DlEql.Items[i].Value == "Greater than")
                            FilStr = FilStr + " > '" + tbMatch.Text + "')";
                    }
                }
            }

            try
            {
                DV.RowFilter = FilStr;
            }
            catch (Exception e)
            {
                ErrorHandler(e, "Major: DV.RowFilter = FilStr");
            }
        }
        
        //Error handeling 
        private void ErrorHandler(Exception e, string ErrorCode)
        {
            
            if (ErrorListMes == null)
            {
                ErrorListMes = new List<string>();
                ErrorListCode = new List<string>();
            }

            ErrorListMes.Add(e.Message);
            ErrorListCode.Add(ErrorCode);
        }

        //If the show report btn has been clicked.
        protected void AddContolPropShowRpt()
        {
            //Below calles method to add report form to child controls and to clear user query controls.
            this.EnsureChildControls();

            //Generate the report and show it. 
            var rptgen = new RdlcRptGen.RdlcGenClass(_DataTable);
            
            if (btnShowRpt.Text == "Show Chart")
            {
                //Look at rptgen to see what happen if null is passed.
                //Type of datapoint, ie sum,count,distrinc and charttyp ie pie,bar,line,column.
                string DataPointType = null;  //Sum, Count, CountDistinct.


                string ChartType = null;   //Column,Bar,Line,Pie
                if (dlRptTyp.Items[dlRptTyp.SelectedIndex].Value == "Pie Chart")
                    ChartType = "Pie";
                else if (dlRptTyp.Items[dlRptTyp.SelectedIndex].Value == "Line Chart")
                    ChartType = "Line";
                else if (dlRptTyp.Items[dlRptTyp.SelectedIndex].Value == "Bar Chart")
                    ChartType = "Bar";

                for (int i = 0; i < lboxSelect.Items.Count; i++)
                {
                    DataPointType = null;
                    if (DisCntDataPointsList != null)
                    {
                        for (int ii = 0; ii < this.DisCntDataPointsList.Count; ii++)
                        {
                            if (DisCntDataPointsList[ii] == lboxSelect.Items[i].Value)
                                DataPointType = "CountDistinct";
                        }
                    }
                    
                    if (lboxSelect.Items[i].Value != dlGrpBy.Items[dlGrpBy.SelectedIndex].Value )
                        rptgen.AddChartDataPoint(lboxSelect.Items[i].Value, DataPointType);
                }

                if (_RptHeader != null)
                    rptgen.AddChartTitle(_RptHeader);

                //Add grouping, if requested
                if (dlGrpBy.Items.Count != 0)
                {
                    for (int i = 0; i < dlGrpBy.Items.Count; i++)
                    {
                        if (dlGrpBy.Items[i].Selected & dlGrpBy.Items[i].Value != "None")
                            rptgen.AddChartTypeAndGrouping(ChartType, dlGrpBy.Items[i].Value);
                    }
                }
                else
                    rptgen.AddChartTypeAndGrouping(ChartType, null);

                rptgen.ChartLables(true, tbxAxisLbl.Text , tbyAxisLbl.Text );
                rptgen.ShowChart(RptViewer);

                return;
            }

            //Add header,if requested
            if (_RptHeader != null)
                rptgen.AddReportHeader(_RptHeader);

            //Add grouping, if requested
            for (int i = 0; i < dlGrpBy.Items.Count; i++)
            {
                if (dlGrpBy.Items[i].Selected & dlGrpBy.Items[i].Value != "None")
                    rptgen.GroupByField = dlGrpBy.Items[i].Value;
            }

            //Add totals, if requested.
            //For report
            for (int i = 0; i < lbTotRptOn.Items.Count; i++)
            {
                if (lbTotRptOn.Items[i].Selected & lbTotRptOn.Items[i].Value != "None")
                    rptgen.AddReportTotalFields(lbTotRptOn.Items[i].Value);
            }

            //For group
            for (int i = 0; i < lbTotGrpOn.Items.Count; i++)
            {
                if (lbTotGrpOn.Items[i].Selected & lbTotGrpOn.Items[i].Value != "None")
                    rptgen.AddGroupTotalFields(lbTotGrpOn.Items[i].Value); 
            }

            
                //rptgen.GenerateRdl("D:\\App\\RdlcGenClass\\TmpDbug.xml"); //For debug only
                
                //Below to keep document map from working. If not disabled, it throws an error about the viewstate.
                //The same error happens when the refreash button is included. 
                RptViewer.ShowRefreshButton = false;
                RptViewer.DocumentMapCollapsed = true;
                RptViewer.ShowDocumentMapButton = false;
                //RptViewer.Style.Add("width", "100%");
                //RptViewer.Width = System.Web.UI.WebControls.Unit.Percentage(100);

                //RptViewer.ZoomMode = Microsoft.Reporting.WebForms.ZoomMode.FullPage;
                //RptViewer.AsyncRendering = false;
                rptgen.ShowReport(RptViewer);
        }

        //Render controls
        protected override void Render(HtmlTextWriter writer)
        {
            base.Render(writer);
        }
        
    }
}

        /*
        Program Flow:
        public SqlDataAdapter SqlAdapter -Called when user adds Sql DataAdapter. 
            3-protected void AddContolPropNoShowRpt() -Add variable properties to child controls.    
        public DataTable DataSource -Called when user adds DataTable. Does nothing if SqlAdapter exists.
            3-protected void AddContolPropNoShowRpt() -Add variable properties to child controls.
        2-protected override void CreateChildControls() -Called by framework to add child controls to form. 
        private void btnSel_Click(object source, EventArgs e) -Button click event for moving avalible fields to selected fields.
        private void btnRemove_Click(object source, EventArgs e) -Button click to remove field from selected fields.
        private void btnShowRpt_Click(object source, EventArgs e) -Show report button click.
            private void AddUserSelToDV() -Add selection info to DataView based on user selections. 
                private void GetFilter(DropDownList DlAndOr, DropDownList DlFields, DropDownList DlEql, TextBox tbMatch, DataView DV)
                1-private void ErrorHandler(Exception e, string ErrorCode)
            private void CallSelData() -Add selection info to Select statement based on user selections.
                private void GetFilterSql(DropDownList DlAndOr, DropDownList DlFields, DropDownList DlEql, TextBox tbMatch)
                1-private void ErrorHandler(Exception e, string ErrorCode)
            protected void AddContolPropShowRpt() -Add additional selection and show report.
                2-protected override void CreateChildControls() -Called to add report to form and clear other controls.     
                rptgen.ShowReport(RptViewer); -Call to RdlcGenClass to generate RDLC file.
        protected override void Render(HtmlTextWriter writer) -Call by framework to render page.
        */
         
        